﻿using BepInEx;
using HarmonyLib;
using System.Reflection;
using System.Collections.Generic;
using UnityEngine;

namespace afld_alwaysbranch
{
    [BepInPlugin(GUID, NAME, MOD_VERS)]
    [BepInDependency("Harb.DisableProgression")]
    public class Plugin : BaseUnityPlugin
    {
        public const string GUID = "ae189449-dfaf-4f2c-9770-cccf461dc548";
        public const string NAME = "Always Branch";
        public const string MOD_VERS = "1.0";

        private void Awake()
        {
            Harmony.CreateAndPatchAll(Assembly.GetExecutingAssembly());
        }

    }

    [HarmonyPatch(typeof(TileManager), nameof(TileManager.SpawnNewTile))]
    public class TileManagerSpawnNewTilePatch
    {
        struct old_tiles_state
        {
            public old_tiles_state(List<GameObject> ltiles, List<GameObject> rtiles, List<GameObject> ttiles, List<GameObject> lTtiles, List<GameObject> lRtiles, List<GameObject> tRtiles) : this()
            {
                Ltiles = ltiles;
                Rtiles = rtiles;
                Ttiles = ttiles;
                LTtiles = lTtiles;
                LRtiles = lRtiles;
                TRtiles = tRtiles;
            }

            public List<GameObject> Ltiles { get; }
            public List<GameObject> Rtiles { get; }
            public List<GameObject> Ttiles { get; }
            public List<GameObject> LTtiles { get; }
            public List<GameObject> LRtiles { get; }
            public List<GameObject> TRtiles { get; }
        }
        static void Prefix(int posX, int posY, int eulerAngle, int[,] ___intArray,
            ref List<GameObject> ___Ltiles, ref List<GameObject> ___Rtiles, ref List<GameObject> ___Ttiles,
            ref List<GameObject> ___LTtiles, ref List<GameObject> ___LRtiles, ref List<GameObject> ___TRtiles,
            ref List<GameObject> ___LTRtiles, out old_tiles_state __state)
        {
            
            __state = new old_tiles_state(___Ltiles, ___Rtiles, ___Ttiles, ___LTtiles, ___LRtiles, ___TRtiles);
            if (null == ___intArray) //let base game method worry about what happens here
            {
                return;
            }
            bool space_below = (___intArray[posX, posY - 1] == 0);
            bool space_above = (___intArray[posX, posY + 1] == 0);
            bool space_left = (___intArray[posX - 1, posY] == 0);
            bool space_right = (___intArray[posX + 1, posY] == 0);
            bool adjusted_space_left = false;
            bool adjusted_space_right = false;
            bool adjusted_space_top = false;
            switch (eulerAngle)
            {
                case 0:
                    adjusted_space_left = space_left;
                    adjusted_space_right = space_right;
                    adjusted_space_top = space_above;
                    break;
                case 90: //clockwise
                    adjusted_space_left = space_above;
                    adjusted_space_top = space_right;
                    adjusted_space_right = space_below;
                    break;
                case 180:
                    adjusted_space_left = space_right;
                    adjusted_space_top = space_below;
                    adjusted_space_right = space_left;
                    break;
                case 270:
                    adjusted_space_left = space_below;
                    adjusted_space_top = space_left;
                    adjusted_space_right = space_above;
                    break;
                default:
                    break;
            }
#if (DEBUG)
            Debug.Log("Angle : " + eulerAngle.ToString() + "; left : " + adjusted_space_left.ToString() + "; top : " + adjusted_space_top.ToString() + "; right : " + adjusted_space_right.ToString());
#endif
            List<GameObject> target_tiles = null;
            if (adjusted_space_left && adjusted_space_right && adjusted_space_top)
            {
                target_tiles = ___LTRtiles;
            }
            else if (adjusted_space_left && adjusted_space_top)
            {
                target_tiles = ___LTtiles;
            }
            else if (adjusted_space_left && adjusted_space_right)
            {
                target_tiles = ___LRtiles;
            }
            else if (adjusted_space_top && adjusted_space_right)
            {
                target_tiles = ___TRtiles;
            }
            if (null != target_tiles)
            {
                ___LTtiles = target_tiles;
                ___LRtiles = target_tiles;
                ___TRtiles = target_tiles;
                ___Ltiles = target_tiles;
                ___Ttiles = target_tiles;
                ___Rtiles = target_tiles;
            }
        }
        static void Postfix(ref List<GameObject> ___Ltiles, ref List<GameObject> ___Rtiles, ref List<GameObject> ___Ttiles,
                ref List<GameObject> ___LTtiles, ref List<GameObject> ___LRtiles, ref List<GameObject> ___TRtiles,
                old_tiles_state __state)
        {
            ___TRtiles = __state.TRtiles;
            ___LRtiles = __state.LRtiles;
            ___LTtiles = __state.LTtiles;
            ___Ltiles = __state.Ltiles;
            ___Rtiles = __state.Rtiles;
            ___Ttiles = __state.Ttiles;
        }
    }
}
